Ginkgo: gko::syn Namespace Reference

| Ginkgo Generated from branch based on main. Ginkgo version 1.11.0 A numerical linear algebra library targeting many-core architectures

Loading...
Searching...
No Matches
gko::syn Namespace Reference

The Synthesizer namespace. More...

## Classes
struct | value_list
| value_list records several values with the same type in template. More...
struct | type_list
| type_list records several types in template More...
struct | range
| range records start, end, step in template More...

## Typedefs
template<typename List1, typename List2>
using | concatenate = typename detail::concatenate_impl<List1, List2>::type
| concatenate combines two value_list into one value_list.
template<typename T>
using | as_list = typename detail::as_list_impl<T>::type
| as_list<T> gives the alias type of as_list_impl<T>::type.

## Functions
template<typename T, T... Value>
constexpr std::array< T, sizeof...(Value)> | as_array (value_list< T, Value... > vl)
| as_array<T> returns the array from value_list.

## Detailed Description

The Synthesizer namespace.

## Typedef Documentation

## ◆ as_list

template<typename T>

using gko::syn::as_list = typename detail::as_list_impl<T>::type

as_list<T> gives the alias type of as_list_impl<T>::type.

It gives a list (itself) if input is already a list, or generates list type from range input.

Template Parameters

  T | list or range

## ◆ concatenate

template<typename List1, typename List2>

using gko::syn::concatenate = typename detail::concatenate_impl<List1, List2>::type

concatenate combines two value_list into one value_list.

Template Parameters

  List1 | the first list
  List2 | the second list

## Function Documentation

## ◆ as_array()

template<typename T, T... Value>

std::array< T, sizeof...(Value)> gko::syn::as_array | ( | value_list< T, Value... > | vl | ) |
| constexpr

as_array<T> returns the array from value_list.

It will be helpful if using for in runtime on the array.

Template Parameters

  T | the type of value_list
  Value | the values of value_list

Parameters

  value_list | the input value_list

Returns
  std::array the std::array contains the values of value_list